package search;

import java.util.ArrayList;

import Environment.Tile;

/**
 * Diese Klasse lässt erbenden Klasse die Suche nach dem Goal des Roboters
 * implementieren. Sie bietet weiterhin die Möglichkeit mit Hilfer der Methode
 * "showPath()" einen gefundenen Pfad durch das Environment zum Ziel über die
 * Konsole anzuzeigen
 * 
 * @author marco
 * 
 */
public abstract class Search
{
	// Diese Liste mit den Tiles des gefundenen Path.
	private ArrayList<Tile> _foundPath;
	private final String _searchType;

	public Search(String searchType)
	{
		_foundPath = new ArrayList<>();
		_searchType = searchType;
	}

	/**
	 * Diese Methode Implementiert des Suchalgorithmus zum Finden des Goals,
	 * ausgehend vom übergebenen Starttile
	 */
	public abstract void search(Tile startTile);

	/**
	 * Gibt eine Stringrepräsentation des gefundenen Pfades über die Konsole
	 * aus.
	 */
	public void showPath()
	{
		int step = 1;
		System.out
				.println("\n\n==================================================");
		System.out.println(_searchType);
		System.out
				.println("==================================================\n");

		System.out.println("Format of shown path:");
		System.out.println("Step <x>: [x-position, y-position, tile-type]\n");
		for (Tile tile : _foundPath)
		{
			System.out.println("Step " + step + ":	" + tile.toString());
			++step;
		}
	}

	public ArrayList<Tile> getFoundPath()
	{
		return _foundPath;
	}

	public void setFoundPath(ArrayList<Tile> path)
	{
		_foundPath = path;
	}
}
